﻿Type=Class
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private cvs As Canvas
	Private mLbl As Label
	Private su As StringUtils
	Public mBase As Panel
End Sub

Public Sub Initialize (Target As Object, EventName As String)

End Sub

Public Sub DesignerCreateView(Base As Panel, lbl As Label, props As Map)
	Dim bmp As Bitmap
	bmp.InitializeMutable(1,1) 'ignore
	cvs.Initialize2(bmp)
	Base.AddView(lbl, 0, 0, Base.Width, Base.Height)
	mLbl = lbl
	Dim r As Reflector
	r.Target = mLbl
	r.RunMethod4("setPadding", Array As Object(0,0,0,0), Array As String("java.lang.int", "java.lang.int", "java.lang.int", "java.lang.int"))
	r.RunMethod4("setIncludeFontPadding", Array As Object(False), Array As String("java.lang.boolean"))
	setText(mLbl.Text)
	mBase = Base
End Sub

Public Sub setText(value As String)
	mLbl.Text = value
	Dim multipleLines As Boolean = mLbl.Text.Contains(" ") 'CRLF gegen " " getauscht, damit auch an Leerzeichen umgebrochen wird
	Dim size As Float
	For size = 2 To 15' Maximale Größe
		If CheckSize(size, multipleLines) Then Exit
	Next
	size = size - 0.5
	If CheckSize(size, multipleLines) Then size = size - 0.5
	mLbl.TextSize = size
End Sub

'returns true if the size is too large
Private Sub CheckSize(size As Float, MultipleLines As Boolean) As Boolean
	mLbl.TextSize = size
	If MultipleLines Then
		Return su.MeasureMultilineTextHeight(mLbl, mLbl.Text) > mLbl.Height
	Else
		Return cvs.MeasureStringWidth(mLbl.Text, mLbl.Typeface, size) > mLbl.Width Or _
			su.MeasureMultilineTextHeight(mLbl, mLbl.Text) > mLbl.Height
	End If
End Sub

Public Sub getText As String
	Return mLbl.Text
End Sub